// Public Domain

#include <stdio.h>
#include <Be.h>
#include "CurbThoseFilenames.h"

int main() 
{
	CurbThoseFilenames	*	app	=	new CurbThoseFilenames();

	app->Run();

	return 0;
}

CurbThoseFilenames::CurbThoseFilenames() : BApplication("application/x-vnd.kirilla.curb-those-filenames")
{
	// void
}

void CurbThoseFilenames::RefsReceived(BMessage * message)
{
	entry_ref	ref;
	int32		index	=	0;
	
	while (message->FindRef("refs", index++, & ref) == B_OK)
		Rename (ref);
}

void CurbThoseFilenames::ReadyToRun (void)
{
	PostMessage(B_QUIT_REQUESTED);
}

void CurbThoseFilenames::Rename(entry_ref ref)
{
	BEntry	entry;
	
	if (entry.SetTo(&ref) != B_OK)
	{
		(new BAlert(0, "Error\n\n"
              "entry.SetTo(&ref) != B_OK",
              "Oki"))->Go(); 
		Quit();
	}

	if(entry.IsDirectory())
	{
		BDirectory dir;
		if (dir.SetTo(&entry) != B_OK)
		{
			(new BAlert(0, "Error\n\n"
              "dir.SetTo(&entry) != B_OK",
              "Oki"))->Go(); 
			Quit();
		}
		
		// for * in directory		
		entry_ref sub_ref;
		while(dir.GetNextRef(&sub_ref) == B_OK)
			Rename(sub_ref);


		// rename directory

		RenameEntry	(& entry);

	}
	else if(entry.IsFile())
	{
		BFile file;
		if (file.SetTo(& entry, B_READ_ONLY) != B_OK)
		{
			printf("Error\n\nfile.SetTo(&entry) != B_OK");
			Quit();
		}
		
		// rename file
	
		RenameEntry	(& entry);
		
	}
	else if (entry.IsSymLink())
	{
		printf("IsSymLink\n");
		
		//	Ignore
		
	}
	else
	{
		BString message	=	"Error\n\nReference is neither file, folder nor symlink:\n";
		BPath	path(&entry);
		message.Append(path.Path());
		
		printf("%s\n", message.String());
	}
}

void
CurbThoseFilenames::RenameEntry (BEntry * entry)
{
	char name [B_FILE_NAME_LENGTH];
	entry->GetName(name);
	
	BString	original_string;
	BString	touched_string;
	
	original_string	=	name;
	touched_string	=	name;
	
	touched_string.ReplaceAll("Å", "A");
	touched_string.ReplaceAll("Ä", "A");
	touched_string.ReplaceAll("Ö", "O");
	touched_string.ReplaceAll("å", "a");
	touched_string.ReplaceAll("ä", "a");
	touched_string.ReplaceAll("ö", "o");
	
	touched_string.ReplaceAll("ü", "u");
	touched_string.ReplaceAll("Ü", "U");
	
	touched_string.ReplaceAll("é", "e");
	touched_string.ReplaceAll("è", "e");
	touched_string.ReplaceAll("È", "E");
	touched_string.ReplaceAll("É", "E");
	
	touched_string.ReplaceAll("Ì", "I");
	touched_string.ReplaceAll("í", "I");
	touched_string.ReplaceAll("í", "i");
	touched_string.ReplaceAll("ì", "i");
	
	touched_string.ReplaceAll("Á", "A");
	touched_string.ReplaceAll("À", "A");
	touched_string.ReplaceAll("á", "a");
	touched_string.ReplaceAll("à", "a");
	
	touched_string.ReplaceAll("ñ", "n");
	touched_string.ReplaceAll("Ñ", "N");
	
	touched_string.ReplaceAll(":", ",");
	touched_string.ReplaceAll("\\", " - ");
	touched_string.ReplaceAll("|", " - ");
	touched_string.ReplaceAll("/", " - ");
	
	touched_string.ReplaceAll("°", "");
	touched_string.ReplaceAll("¥", " - ");
	touched_string.ReplaceAll("?", "");

	if (touched_string != original_string)
	{
		printf("Original: %s\n", original_string.String());
		printf("Touched: %s\n\n", touched_string.String());
		
		entry->Rename(touched_string.String());
	}
}
